%global service neutron


%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:           openstack-%{service}
Version:        8.4.0
Release:        17%{?dist}
Epoch:          1
Summary:        OpenStack Networking Service

License:        ASL 2.0
URL:            http://launchpad.net/%{service}/

Source0:        http://tarballs.openstack.org/%{service}/%{service}-%{version}%{?milestone}.tar.gz

Source1:        %{service}.logrotate
Source2:        %{service}-sudoers
Source10:       neutron-server.service
Source11:       neutron-linuxbridge-agent.service
Source12:       neutron-openvswitch-agent.service
Source13:       neutron-bgp-dragent.service
Source15:       neutron-dhcp-agent.service
Source16:       neutron-l3-agent.service
Source17:       neutron-metadata-agent.service
Source18:       neutron-ovs-cleanup.service
Source19:       neutron-macvtap-agent.service
Source20:       neutron-metering-agent.service
Source21:       neutron-sriov-nic-agent.service
Source22:       neutron-netns-cleanup.service
Source23:       neutron-netns-cleanup.init
Source24:       neutron-ovs-cleanup.init
Source25:       NetnsCleanup.ocf_ra
Source26:       OVSCleanup.ocf_ra
Source27:       NeutronScale.ocf_ra
Source29:       neutron-rpc-server.service

Source30:       %{service}-dist.conf
Source31:       conf.README
Source32:       neutron-linuxbridge-cleanup.service
Source33:       neutron-enable-bridge-firewall.sh
Source34:       neutron-l2-agent-sysctl.conf
# We use the legacy service to load modules because it allows to gracefully
# ignore a missing kernel module (f.e. br_netfilter on earlier kernels). It's
# essentially because .modules files are shell scripts.
Source35:       neutron-l2-agent.modules

#
# patches_base=+1
#
Patch0001: 0001-Revert-Revert-Remove-threading-before-process-forkin.patch
Patch0002: 0002-Calculate-MTU-on-every-network-fetch-instead-of-on-c.patch
Patch0003: 0003-Reset-provider-network-bridges-to-standalone-fail-mo.patch
Patch0004: 0004-Fix-passing-error-physical-network-for-get_mtu.patch
Patch0005: 0005-Update-MTU-on-existing-devices.patch
Patch0006: 0006-Revert-Setup-firewall-filters-only-for-required-port.patch
Patch0007: 0007-DHCP-enhance-DHCPAgent-startup-procedure.patch
Patch0008: 0008-Kill-neutron-keepalived-state-change-gracefully.patch
Patch0009: 0009-Add-fullstack-logging.patch
Patch0010: 0010-fullstack-test-for-east-west-traffic.patch
Patch0011: 0011-fullstack-test-for-snat-and-floatingip.patch
Patch0012: 0012-fullstack-test-for-IPv6-east-west-traffic.patch
Patch0013: 0013-Add-fullstack-cross-process-port-ip-address-fixtures.patch
Patch0014: 0014-Throttle-SIGHUPs-to-keepalived.patch
Patch0015: 0015-Adds-a-default-reload-callback-to-ProcessManager.patch
Patch0016: 0016-Get-rid-of-delete_subnet-method-in-ML2.patch
Patch0017: 0017-Add-http_proxy_to_wsgi-to-api-paste.patch
Patch0018: 0018-Neutron-versions-api-now-has-its-own-middleware-pipe.patch
Patch0019: 0019-Emit-router-payload-only-during-failures.patch
Patch0020: 0020-Avoid-router-ri.process-if-initialize-fails.patch
Patch0021: 0021-Set-HA-network-port-to-DOWN-when-l3-agent-starts.patch
Patch0022: 0022-Wait-2-seconds-between-gratuitous-ARP-updates-instea.patch
Patch0023: 0023-Fix-typo-in-l3-agent-test.patch
Patch0024: 0024-Functional-tests-change-assert-to-wait_until_true.patch
Patch0025: 0025-Add-check-for-ha-state.patch
Patch0026: 0026-Fix-test_keepalived_ipv6_support-for-Keepalived-v1.2.patch
Patch0027: 0027-Make-use-of-w-argument-for-iptables-calls.patch
Patch0028: 0028-Fixed-upper-constraints-file-link.patch
Patch0029: 0029-Notify-port_update-to-agent-for-status-change.patch
Patch0030: 0030-iptables-don-t-log-lock-error-if-we-haven-t-passed-w.patch
Patch0031: 0031-Skip-setup_port_filters-for-skipped_devices.patch
Patch0032: 0032-Change-OVS-agent-to-update-skipped-port-status-to-DO.patch
Patch0033: 0033-Fix-bad-l3-agent-backport-to-stable-newton.patch
Patch0034: 0034-Move-check_ha_state_for_router-into-notification-cod.patch
Patch0035: 0035-Don-t-wait-on-TRY_AGAIN-when-calling-commit_block.patch
Patch0036: 0036-Call-update_all_ha_network_port_statuses-on-agent-st.patch
Patch0037: 0037-functional-Fix-ovsdb-monitor-waiting-for-first-event.patch
Patch0038: 0038-ovs-lib-Pass-string-as-udp-port-to-ovsdb.patch
Patch0039: 0039-l3_ha-only-pass-host-into-update_port-when-updating-.patch
Patch0040: 0040-Retry-DBDuplicate-errors-in-retry-decorator.patch

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  python2-devel
BuildRequires:  python-d2to1
BuildRequires:  python-keystoneauth1 >= 2.1.0
BuildRequires:  python-keystonemiddleware
BuildRequires:  python-neutron-lib
BuildRequires:  python-novaclient
BuildRequires:  python-oslo-concurrency
BuildRequires:  python-oslo-config
BuildRequires:  python-oslo-db
BuildRequires:  python-oslo-log
BuildRequires:  python-oslo-messaging
BuildRequires:  python-oslo-policy
BuildRequires:  python-oslo-rootwrap
BuildRequires:  python-oslo-service
BuildRequires:  python-pbr >= 1.6
BuildRequires:  python-pecan
BuildRequires:  python-setuptools
BuildRequires:  systemd-units

Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}

# dnsmasq is not a hard requirement, but is currently the only option
# when neutron-dhcp-agent is deployed.
Requires:       dnsmasq
Requires:       dnsmasq-utils

# radvd is not a hard requirement, but is currently the only option
# for IPv6 deployments.
Requires:       radvd

# dibbler is not a hard requirement, but is currently the default option
# for IPv6 prefix delegation.
Requires:       dibbler-client

# conntrack is not a hard requirement, but is currently used by L3 agent
# to immediately drop connections after a floating IP is disassociated
Requires:       conntrack-tools

# keepalived is not a hard requirement, but is currently used by DVR L3
# agent
Requires:       keepalived

# Those are not hard requirements, ipset is used by ipset-cleanup in the subpackage,
# and iptables is used by the l3-agent which currently is not in a separate package.
Requires:       ipset
Requires:       iptables

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

Obsoletes:      openstack-%{service}-dev-server

%description
Neutron is a virtual network service for Openstack. Just like
OpenStack Nova provides an API to dynamically request and configure
virtual servers, Neutron provides an API to dynamically request and
configure virtual networks. These networks connect "interfaces" from
other OpenStack services (e.g., virtual NICs from Nova VMs). The
Neutron API supports extensions to provide advanced network
capabilities (e.g., QoS, ACLs, network monitoring, etc.)


%package -n python-%{service}
Summary:        Neutron Python libraries
Requires:       python-alembic >= 0.8.0
Requires:       python-debtcollector >= 1.2.0
Requires:       python-designateclient >= 1.5.0
Requires:       python-eventlet >= 0.17.4
Requires:       python-greenlet >= 0.3.2
Requires:       python-httplib2 >= 0.7.5
Requires:       python-jinja2 >= 2.6
Requires:       python-keystoneauth1 >= 2.1.0
Requires:       python-keystoneclient >= 1.6.0
Requires:       python-keystonemiddleware >= 4.0.0
Requires:       python-netaddr >= 0.7.12
Requires:       python-netifaces >= 0.10.4
Requires:       python-neutronclient >= 2.6.0
Requires:       python-neutron-lib
Requires:       python-novaclient >= 2.29.0
Requires:       python-oslo-concurrency >= 3.5.0
Requires:       python-oslo-config >= 2:3.7.0
Requires:       python-oslo-context >= 0.2.0
Requires:       python-oslo-db >= 4.1.0
Requires:       python-oslo-i18n >= 1.5.0
Requires:       python-oslo-log >= 1.8.0
Requires:       python-oslo-messaging >= 4.0.0
Requires:       python-oslo-middleware >= 3.0.0
Requires:       python-oslo-policy >= 0.5.0
Requires:       python-oslo-reports >= 0.6.0
Requires:       python-oslo-rootwrap >= 2.0.0
Requires:       python-oslo-serialization >= 1.10.0
Requires:       python-oslo-service >= 1.0.0
Requires:       python-oslo-utils >= 3.5.0
Requires:       python-oslo-versionedobjects >= 1.5.0
Requires:       python-oslo-context >= 0.2.0
Requires:       python-paste
Requires:       python-paste-deploy >= 1.5.0
Requires:       python-pecan >= 1.0.0
Requires:       python-pbr >= 1.6
Requires:       python-requests >= 2.5.2
Requires:       python-retrying >= 1.2.3
Requires:       python-routes >= 1.12.3
Requires:       python-ryu >= 3.23.2
Requires:       python-six >= 1.9.0
Requires:       python-sqlalchemy >= 1.0.10
Requires:       python-stevedore >= 1.5.0
Requires:       python-webob >= 1.2.3



%description -n python-%{service}
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains the Neutron Python library.


%package -n python-%{service}-tests
Summary:        Neutron tests
Requires:       python-%{service} = %{epoch}:%{version}-%{release}
Requires:       python-ddt >= 1.0.1
Requires:       python-fixtures >= 1.3.1
Requires:       python-mock >= 1.2
Requires:       python-subunit >= 0.0.18
Requires:       python-requests-mock >= 0.6.0
Requires:       python-testrepository >= 0.0.18
Requires:       python-testtools >= 1.4.0
Requires:       python-testresources >= 0.2.4
Requires:       python-testscenarios >= 0.4
Requires:       python-oslotest >= 1.10.0
Requires:       python-os-testr >= 0.4.1
Requires:       python-PyMySQL >= 0.6.2
Requires:       python-webtest >= 1.3.4
Requires:       python-tempest-lib >= 0.14.0


# pstree is used during functional testing to ensure our internal
# libraries managing processes work correctly.
Requires:       psmisc


%description -n python-%{service}-tests
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains Neutron test files.


%package common
Summary:        Neutron common files
Requires(pre): shadow-utils
Requires:       python-%{service} = %{epoch}:%{version}-%{release}
Requires:       sudo


%description common
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains Neutron common files.


%package bgp-dragent
Summary:        Neutron BGP Dynamic Routing agent
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description bgp-dragent
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains the Neutron BGP Dynamic Routing agent that will host
different BGP speaking drivers and makes the required BGP peering session/s for
Neutron.


%package linuxbridge
Summary:        Neutron Linuxbridge agent
Requires:       bridge-utils
Requires:       ebtables
Requires:       ipset
Requires:       iptables
# kmod is needed to get access to /usr/sbin/modprobe needed by
# neutron-enable-bridge-firewall.sh triggered by the service unit file
Requires:       kmod
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description linuxbridge
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains the Neutron agent that implements virtual
networks using VLAN or VXLAN using Linuxbridge technology.


%package macvtap-agent
Summary:        Neutron macvtap agent
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description macvtap-agent
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains the Neutron agent that implements
macvtap attachments for libvirt qemu/kvm instances.


%package ml2
Summary:        Neutron ML2 plugin
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}
# needed for brocade and cisco drivers
Requires:       python-ncclient


%description ml2
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains a Neutron plugin that allows the use of drivers
to support separately extensible sets of network types and the mechanisms
for accessing those types.


%package openvswitch
Summary:        Neutron openvswitch plugin
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}
# We require openvswitch when using vsctl to access ovsdb;
# but if we use native access, then we just need python bindings.
# since we don't know what users actually use, we depend on both.
Requires:       ipset
Requires:       iptables
Requires:       openvswitch
Requires:       python-openvswitch
# kmod is needed to get access to /usr/sbin/modprobe needed by
# neutron-enable-bridge-firewall.sh triggered by the service unit file
Requires:       kmod


%description openvswitch
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains the Neutron plugin that implements virtual
networks using Open vSwitch.


%package metering-agent
Summary:        Neutron bandwidth metering agent
Requires:       iptables
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description metering-agent
Neutron provides an API to measure bandwidth utilization

This package contains the Neutron agent responsible for generating bandwidth
utilization notifications.


%package rpc-server
Summary:        Neutron (RPC only) Server
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description rpc-server
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains an alternative Neutron server that handles AMQP RPC
workload only.


%package sriov-nic-agent
Summary:        Neutron SR-IOV NIC agent
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description sriov-nic-agent
Neutron allows to run virtual instances using SR-IOV NIC hardware

This package contains the Neutron agent to support advanced features of
SR-IOV network cards.


%prep
%autosetup -n %{service}-%{upstream_version} -S git

find %{service} -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

# Let's handle dependencies ourseleves
rm -f requirements.txt

# Kill egg-info in order to generate new SOURCES.txt
rm -rf neutron.egg-info


%build
export SKIP_PIP_INSTALL=1
%{__python2} setup.py build

# Generate configuration files
PYTHONPATH=. tools/generate_config_file_samples.sh
find etc -name *.sample | while read filename
do
    filedir=$(dirname $filename)
    file=$(basename $filename .sample)
    mv ${filename} ${filedir}/${file}
done

# Loop through values in neutron-dist.conf and make sure that the values
# are substituted into the neutron.conf as comments. Some of these values
# will have been uncommented as a way of upstream setting defaults outside
# of the code. For notification_driver, there are commented examples
# above uncommented settings, so this specifically skips those comments
# and instead comments out the actual settings and substitutes the
# correct default values.
while read name eq value; do
  test "$name" && test "$value" || continue
  if [ "$name" = "notification_driver" ]; then
    sed -ri "0,/^$name *=/{s!^$name *=.*!# $name = $value!}" etc/%{service}.conf
  else
    sed -ri "0,/^(#)? *$name *=/{s!^(#)? *$name *=.*!# $name = $value!}" etc/%{service}.conf
  fi
done < %{SOURCE30}

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# Remove unused files
rm -rf %{buildroot}%{python2_sitelib}/bin
rm -rf %{buildroot}%{python2_sitelib}/doc
rm -rf %{buildroot}%{python2_sitelib}/tools

# Move rootwrap files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/%{service}/rootwrap
mv %{buildroot}/usr/etc/%{service}/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/%{service}/rootwrap

# Move config files to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}
mv %{buildroot}/usr/etc/%{service}/* %{buildroot}%{_sysconfdir}/%{service}
mv %{buildroot}%{_sysconfdir}/%{service}/api-paste.ini %{buildroot}%{_datadir}/%{service}/api-paste.ini

# The generated config files are not moved automatically by setup.py
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/plugins/ml2

mv etc/%{service}.conf %{buildroot}%{_sysconfdir}/%{service}/%{service}.conf
for agent in dhcp l3 metadata metering
do
  mv etc/${agent}_agent.ini %{buildroot}%{_sysconfdir}/%{service}/${agent}_agent.ini
done
for file in linuxbridge_agent ml2_conf ml2_conf_sriov openvswitch_agent sriov_agent
do
  mv etc/%{service}/plugins/ml2/${file}.ini %{buildroot}%{_sysconfdir}/%{service}/plugins/ml2/${file}.ini
done

# Install logrotate
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-%{service}

# Install sudoers
install -p -D -m 440 %{SOURCE2} %{buildroot}%{_sysconfdir}/sudoers.d/%{service}

# Install systemd units
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/neutron-server.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/neutron-linuxbridge-agent.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/neutron-openvswitch-agent.service
install -p -D -m 644 %{SOURCE13} %{buildroot}%{_unitdir}/neutron-bgp-dragent.service
install -p -D -m 644 %{SOURCE15} %{buildroot}%{_unitdir}/neutron-dhcp-agent.service
install -p -D -m 644 %{SOURCE16} %{buildroot}%{_unitdir}/neutron-l3-agent.service
install -p -D -m 644 %{SOURCE17} %{buildroot}%{_unitdir}/neutron-metadata-agent.service
install -p -D -m 644 %{SOURCE18} %{buildroot}%{_unitdir}/neutron-ovs-cleanup.service
install -p -D -m 644 %{SOURCE19} %{buildroot}%{_unitdir}/neutron-macvtap-agent.service
install -p -D -m 644 %{SOURCE20} %{buildroot}%{_unitdir}/neutron-metering-agent.service
install -p -D -m 644 %{SOURCE21} %{buildroot}%{_unitdir}/neutron-sriov-nic-agent.service
install -p -D -m 644 %{SOURCE22} %{buildroot}%{_unitdir}/neutron-netns-cleanup.service
install -p -D -m 644 %{SOURCE29} %{buildroot}%{_unitdir}/neutron-rpc-server.service
install -p -D -m 644 %{SOURCE32} %{buildroot}%{_unitdir}/neutron-linuxbridge-cleanup.service

# Install helper scripts
install -p -D -m 755 %{SOURCE33} %{buildroot}%{_bindir}/neutron-enable-bridge-firewall.sh

# Install scripts for pacemaker support
install -p -D -m 755 %{SOURCE23} %{buildroot}%{_prefix}/lib/ocf/lib/neutron/neutron-netns-cleanup
install -p -D -m 755 %{SOURCE24} %{buildroot}%{_prefix}/lib/ocf/lib/neutron/neutron-ovs-cleanup
install -p -D -m 755 %{SOURCE25} %{buildroot}%{_prefix}/lib/ocf/resource.d/neutron/NetnsCleanup
install -p -D -m 755 %{SOURCE26} %{buildroot}%{_prefix}/lib/ocf/resource.d/neutron/OVSCleanup
install -p -D -m 755 %{SOURCE27} %{buildroot}%{_prefix}/lib/ocf/resource.d/neutron/NeutronScale

# Install sysctl and modprobe config files to enable bridge firewalling
# NOTE(ihrachys) we effectively duplicate same settings for each affected l2
# agent. This can be revisited later.
install -p -D -m 644 %{SOURCE34} %{buildroot}%{_sysctldir}/99-neutron-openvswitch-agent.conf
install -p -D -m 644 %{SOURCE34} %{buildroot}%{_sysctldir}/99-neutron-linuxbridge-agent.conf
install -p -D -m 755 %{SOURCE35} %{buildroot}%{_sysconfdir}/sysconfig/modules/neutron-openvswitch-agent.modules
install -p -D -m 755 %{SOURCE35} %{buildroot}%{_sysconfdir}/sysconfig/modules/neutron-linuxbridge-agent.modules

# Install README file that describes how to configure services with custom configuration files
install -p -D -m 755 %{SOURCE31} %{buildroot}%{_sysconfdir}/%{service}/conf.d/README

# Setup directories
install -d -m 755 %{buildroot}%{_datadir}/%{service}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}
install -d -m 755 %{buildroot}%{_localstatedir}/log/%{service}
install -d -m 755 %{buildroot}%{_localstatedir}/run/%{service}

# Install dist conf
install -p -D -m 640 %{SOURCE30} %{buildroot}%{_datadir}/%{service}/%{service}-dist.conf

# Create and populate configuration directory for L3 agent that is not accessible for user modification
mkdir -p %{buildroot}%{_datadir}/%{service}/l3_agent
ln -s %{_sysconfdir}/%{service}/l3_agent.ini %{buildroot}%{_datadir}/%{service}/l3_agent/l3_agent.conf

# Create dist configuration directory for neutron-server (may be filled by advanced services)
mkdir -p %{buildroot}%{_datadir}/%{service}/server

# Create configuration directories for all services that can be populated by users with custom *.conf files
mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/common
for service in server rpc-server ovs-cleanup netns-cleanup linuxbridge-cleanup bgp-dragent macvtap-agent; do
    mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/%{service}-$service
done
for service in linuxbridge openvswitch dhcp l3 metadata metering sriov-nic; do
    mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/%{service}-$service-agent
done


%pre common
getent group %{service} >/dev/null || groupadd -r %{service}
getent passwd %{service} >/dev/null || \
    useradd -r -g %{service} -d %{_sharedstatedir}/%{service} -s /sbin/nologin \
    -c "OpenStack Neutron Daemons" %{service}
exit 0


%post
%systemd_post neutron-dhcp-agent.service
%systemd_post neutron-l3-agent.service
%systemd_post neutron-metadata-agent.service
%systemd_post neutron-server.service
%systemd_post neutron-netns-cleanup.service
%systemd_post neutron-ovs-cleanup.service
%systemd_post neutron-linuxbridge-cleanup.service


%preun
%systemd_preun neutron-dhcp-agent.service
%systemd_preun neutron-l3-agent.service
%systemd_preun neutron-metadata-agent.service
%systemd_preun neutron-server.service
%systemd_preun neutron-netns-cleanup.service
%systemd_preun neutron-ovs-cleanup.service
%systemd_preun neutron-linuxbridge-cleanup.service


%postun
%systemd_postun_with_restart neutron-dhcp-agent.service
%systemd_postun_with_restart neutron-l3-agent.service
%systemd_postun_with_restart neutron-metadata-agent.service
%systemd_postun_with_restart neutron-server.service


%post bgp-dragent
%systemd_post neutron-bgp-dragent.service


%preun bgp-dragent
%systemd_preun neutron-bgp-dragent.service


%postun bgp-dragent
%systemd_postun_with_restart neutron-bgp-dragent.service


%post macvtap-agent
%systemd_post neutron-macvtap-agent.service


%preun macvtap-agent
%systemd_preun neutron-macvtap-agent.service


%postun macvtap-agent
%systemd_postun_with_restart neutron-macvtap-agent.service


%post linuxbridge
%systemd_post neutron-linuxbridge-agent.service
oldconf=%{_sysconfdir}/%{service}/plugins/linuxbridge/linuxbridge_conf.ini
newconf=%{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
if [ $1 -gt 1 ]; then
    if [ -e $oldconf ]; then
        # Imitate noreplace
        cp $newconf ${newconf}.rpmnew
        cp $oldconf $newconf
    fi
fi


%preun linuxbridge
%systemd_preun neutron-linuxbridge-agent.service


%postun linuxbridge
%systemd_postun_with_restart neutron-linuxbridge-agent.service


%post openvswitch
%systemd_post neutron-openvswitch-agent.service
oldconf=%{_sysconfdir}/%{service}/plugins/openvswitch/ovs_neutron_plugin.ini
newconf=%{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini
if [ $1 -gt 1 ]; then
    if [ -e $oldconf ]; then
        # Imitate noreplace
        cp $newconf ${newconf}.rpmnew
        cp $oldconf $newconf
    fi
fi


%preun openvswitch
%systemd_preun neutron-openvswitch-agent.service


%postun openvswitch
%systemd_postun_with_restart neutron-openvswitch-agent.service


%post metering-agent
%systemd_post neutron-metering-agent.service


%preun metering-agent
%systemd_preun neutron-metering-agent.service


%postun metering-agent
%systemd_postun_with_restart neutron-metering-agent.service


%post sriov-nic-agent
%systemd_post neutron-sriov-nic-agent.service


%preun sriov-nic-agent
%systemd_preun neutron-sriov-nic-agent.service


%postun sriov-nic-agent
%systemd_postun_with_restart neutron-sriov-nic-agent.service


%files
%license LICENSE
%{_bindir}/neutron-db-manage
%{_bindir}/neutron-debug
%{_bindir}/neutron-dhcp-agent
%{_bindir}/neutron-ipset-cleanup
%{_bindir}/neutron-keepalived-state-change
%{_bindir}/neutron-l3-agent
%{_bindir}/neutron-linuxbridge-cleanup
%{_bindir}/neutron-metadata-agent
%{_bindir}/neutron-netns-cleanup
%{_bindir}/neutron-ns-metadata-proxy
%{_bindir}/neutron-ovs-cleanup
%{_bindir}/neutron-pd-notify
%{_bindir}/neutron-sanity-check
%{_bindir}/neutron-server
%{_bindir}/neutron-usage-audit
%{_prefix}/lib/ocf/lib/neutron/neutron-netns-cleanup
%{_prefix}/lib/ocf/lib/neutron/neutron-ovs-cleanup
%{_prefix}/lib/ocf/resource.d/neutron/NetnsCleanup
%{_prefix}/lib/ocf/resource.d/neutron/OVSCleanup
%{_prefix}/lib/ocf/resource.d/neutron/NeutronScale
%{_unitdir}/neutron-dhcp-agent.service
%{_unitdir}/neutron-l3-agent.service
%{_unitdir}/neutron-metadata-agent.service
%{_unitdir}/neutron-server.service
%{_unitdir}/neutron-netns-cleanup.service
%{_unitdir}/neutron-ovs-cleanup.service
%{_unitdir}/neutron-linuxbridge-cleanup.service
%attr(-, root, %{service}) %{_datadir}/%{service}/api-paste.ini
%dir %{_datadir}/%{service}/l3_agent
%dir %{_datadir}/%{service}/server
%{_datadir}/%{service}/l3_agent/*.conf
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/dhcp_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/l3_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/metadata_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/policy.json
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-dhcp-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-l3-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-metadata-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-server
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-netns-cleanup
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-ovs-cleanup
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-linuxbridge-cleanup


%files -n python-%{service}-tests
%license LICENSE
%{python2_sitelib}/%{service}/tests


%files -n python-%{service}
%license LICENSE
%{python2_sitelib}/%{service}
%{python2_sitelib}/%{service}-*.egg-info
%exclude %{python2_sitelib}/%{service}/tests


%files common
%license LICENSE
%doc README.rst
# though this script is not exactly needed on all nodes but for ovs and
# linuxbridge agents only, it's probably good enough to put it here
%{_bindir}/neutron-enable-bridge-firewall.sh
%{_bindir}/neutron-rootwrap
%{_bindir}/neutron-rootwrap-daemon
%{_bindir}/neutron-rootwrap-xen-dom0
%dir %{_sysconfdir}/%{service}
%{_sysconfdir}/%{service}/conf.d/README
%dir %{_sysconfdir}/%{service}/conf.d
%dir %{_sysconfdir}/%{service}/conf.d/common
%dir %{_sysconfdir}/%{service}/plugins
%attr(-, root, %{service}) %{_datadir}/%{service}/%{service}-dist.conf
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/%{service}.conf
%config(noreplace) %{_sysconfdir}/%{service}/rootwrap.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/*
%{_sysconfdir}/sudoers.d/%{service}
%dir %attr(0755, %{service}, %{service}) %{_sharedstatedir}/%{service}
%dir %attr(0750, %{service}, %{service}) %{_localstatedir}/log/%{service}
%dir %{_datarootdir}/%{service}
%dir %{_datarootdir}/%{service}/rootwrap
%{_datarootdir}/%{service}/rootwrap/debug.filters
%{_datarootdir}/%{service}/rootwrap/dhcp.filters
%{_datarootdir}/%{service}/rootwrap/dibbler.filters
%{_datarootdir}/%{service}/rootwrap/ebtables.filters
%{_datarootdir}/%{service}/rootwrap/ipset-firewall.filters
%{_datarootdir}/%{service}/rootwrap/iptables-firewall.filters
%{_datarootdir}/%{service}/rootwrap/l3.filters


%files bgp-dragent
%license LICENSE
%{_bindir}/neutron-bgp-dragent
%{_unitdir}/neutron-bgp-dragent.service
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-bgp-dragent


%files linuxbridge
%license LICENSE
%{_bindir}/neutron-linuxbridge-agent
%{_unitdir}/neutron-linuxbridge-agent.service
%{_datarootdir}/%{service}/rootwrap/linuxbridge-plugin.filters
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-linuxbridge-agent
%{_sysctldir}/99-neutron-linuxbridge-agent.conf
%{_sysconfdir}/sysconfig/modules/neutron-linuxbridge-agent.modules


%files macvtap-agent
%license LICENSE
%{_bindir}/neutron-macvtap-agent
%{_unitdir}/neutron-macvtap-agent.service
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-macvtap-agent


%files ml2
%license LICENSE
%doc %{service}/plugins/ml2/README
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/*.ini
%exclude %{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
%exclude %{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini


%files openvswitch
%license LICENSE
%{_bindir}/neutron-openvswitch-agent
%{_unitdir}/neutron-openvswitch-agent.service
%{_datarootdir}/%{service}/rootwrap/openvswitch-plugin.filters
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-openvswitch-agent
%{_sysctldir}/99-neutron-openvswitch-agent.conf
%{_sysconfdir}/sysconfig/modules/neutron-openvswitch-agent.modules


%files metering-agent
%license LICENSE
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/metering_agent.ini
%{_unitdir}/neutron-metering-agent.service
%{_bindir}/neutron-metering-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-metering-agent


%files rpc-server
%license LICENSE
%{_bindir}/neutron-rpc-server
%{_unitdir}/neutron-rpc-server.service
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-rpc-server


%files sriov-nic-agent
%license LICENSE
%{_unitdir}/neutron-sriov-nic-agent.service
%{_bindir}/neutron-sriov-nic-agent
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/sriov_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-sriov-nic-agent


%changelog
* Mon Feb 12 2018 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.4.0-17
- Retry DBDuplicate errors in retry decorator (rhbz#1533592)

* Fri Jan 19 2018 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.4.0-16
- l3_ha: only pass host into update_port when updating router port bindings (rhbz#1535623)

* Wed Jan 10 2018 Jakub Libosvar <libosvar@redhat.com> 1:8.4.0-15
- ovs-lib: Pass string as udp port to ovsdb (rhbz#1533885)

* Thu Jan 04 2018 Terry Wilson <twilson@redhat.com> 1:8.4.0-14
- Remove timeout for neutron-ovs-cleanup stop/start (rhbz#1531143)

* Fri Dec 08 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.4.0-13
- functional: Fix ovsdb-monitor waiting for first events (rhbz#1523853)

* Fri Dec 08 2017 Jakub Libosvar <libosvar@redhat.com> 1:8.4.0-12
- Call update_all_ha_network_port_statuses on agent start (rhbz#1517710)

* Fri Nov 17 2017 venkata anil <anilvenkata@redhat.com> 1:8.4.0-11
- Don't wait on TRY_AGAIN when calling commit_block() (rhbz#1513850)

* Wed Nov 15 2017 Brian Haley <bhaley@redhat.com> 1:8.4.0-10
- Move check_ha_state_for_router() into notification code (rhbz#1508548)

* Wed Nov 08 2017 Brian Haley <bhaley@redhat.com> 1:8.4.0-9
- Fix bad l3-agent backport to stable/newton (rhbz#1508091)
- Change OVS agent to update skipped port status to DOWN (rhbz#1509091)
- Skip setup_port_filters for skipped_devices (rhbz#1509091)

* Tue Oct 24 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.4.0-8
- iptables: don't log lock error if we haven't passed -w (rhbz#1505520)
- Notify port_update to agent for status change (rhbz#1505771)

* Tue Oct 10 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.4.0-7
- Fixed upper constraints file link

* Tue Sep 19 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.4.0-6
- Make use of -w argument for iptables calls (rhbz#1489071)

* Tue Aug 29 2017 venkata anil <anilvenkata@redhat.com> 1:8.4.0-5
- Fix test_keepalived_ipv6_support for Keepalived v1.2.20, rhbz#1484282
- Add check for ha state
- Functional tests: change assert to wait_until_true

* Tue Aug 15 2017 Jakub Libosvar <libosvar@redhat.com> 1:8.4.0-4
- Fix pep8 and py27 test suites (rhbz#1481747)

* Wed Aug 09 2017 Jason Joyce <jjoyce@redhat.com> 1:8.4.0-3
- Updating test requirements for OSP 9 versions. rhbz#1471652

* Fri Jul 21 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.4.0-2
- Enable bridge firewalling on platform level, rhbz#1473371, rhbz#1474117

* Fri Jul 21 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.3.0-11.1
- Enable bridge firewalling on platform level, rhbz#1473371, rhbz#1474117

* Wed Jul 19 2017 Nir Magnezi <nmagnezi@redhat.com> 1:8.4.0-1
- Update to 8.4.0, rhbz#1471735

* Mon Jul 17 2017 Venkata Anil Kommaddi <vkommadi@redhat.com> 1:8.3.0-13
- Added new tests requirements, rhbz#1471652

* Wed Jul 05 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.3.0-12
- Avoid trace in _notify_l3_agent_ha_port_update, rhbz#1461110
- Check for ha port to become ACTIVE, rhbz#1461110
- Wait 2 seconds between gratuitous ARP updates instead of 1 second (rhbz#1452884)
- Set HA network port to DOWN when l3 agent starts, rhbz#1461110

* Tue Jun 13 2017 Venkata Anil Kommaddi <vkommadi@redhat.com> 1:8.3.0-11
- Avoid router ri.process if initialize() fails (rhbz#1437818)
- Emit router payload only during failures

* Mon Jun 05 2017 Bernard Cafarelli <bcafarel@redhat.com> 1:8.3.0-10
- Neutron versions api now has its own middleware pipeline, rhbz#1451508

* Wed May 17 2017 Bernard Cafarelli <bcafarel@redhat.com> 1:8.3.0-9
- Add http_proxy_to_wsgi to api-paste (rhbz#1451508)
- Get rid of delete_subnet method in ML2 (rhbz#1436067)

* Tue Apr 04 2017 Nir Magnezi <nmagnezi@redhat.com> 1:8.3.0-8
- Adds a default reload callback to ProcessManager (rhbz#1431152)
- Throttle SIGHUPs to keepalived (rhbz#1398286)
- Add fullstack cross-process port/ip address fixtures
- fullstack: test for IPv6 east-west traffic (rhbz#1398286)
- fullstack: test for snat and floatingip (rhbz#1398286)
- fullstack: test for east west traffic (rhbz#1398286)
- Add fullstack logging (rhbz#1398286)

* Fri Mar 31 2017 Daniel Alvarez <dalvarez@redhat.com> 1:8.3.0-7
- Kill neutron-keepalived-state-change gracefully, rhbz#1383448

* Tue Mar 28 2017 Daniel Alvarez <dalvarez@redhat.com> 1:8.3.0-6
- Don't depend on translated strings for error check, rhbz#1418329

* Fri Mar 17 2017 Daniel Alvarez <dalvarez@redhat.com> 1:8.3.0-5
- DHCP: enhance DHCPAgent startup procedure, rhbz#1433255

* Mon Mar 06 2017 Daniel Alvarez <dalvarez@redhat.com> 1:8.3.0-4
- Revert "Setup firewall filters only for required ports" (rhbz#1429331)

* Tue Feb 07 2017 Venkata Anil Kommaddi <vkommadi@redhat.com> 1:8.3.0-3
- Fixed 0011-l3-ha-Send-gratuitous-ARP-when-new-floating-IP-is-ad.patch, rhbz#1392743

* Thu Jan 19 2017 Venkata Anil Kommaddi <vkommadi@redhat.com> 1:8.3.0-2
- Rebase to 8.3.0 removed dibbler.filters, added it back, rhbz#1392743

* Wed Jan 18 2017 Venkata Anil Kommaddi <vkommadi@redhat.com> 1:8.3.0-1
- Update to 8.3.0, rhbz#1392743

* Thu Jan 05 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.1.2-15
- Update MTU on existing devices (rhbz#1400179)

* Thu Dec 01 2016 Jakub Libosvar <libosvar@redhat.com> 1:8.1.2-14.el7
- l3-ha: Send gratuitous ARP when new floating IP is added, rhbz#1384108
- LinuxBridge: Pass host into get_devices_details_list, rhbz#1397519

* Thu Nov 24 2016 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.1.2-13
- Fix passing error physical network for get_mtu (rhbz#1396533)
- l2pop fdb flows for HA router ports (rhbz#1395533)

* Tue Nov 15 2016 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.1.2-12
- Update metadata proxy when subnet add/delete (rhbz#1394880)
- Add 169.254.169.254 when enable force_metadata
- Move class properties to instances for dhcp tests

* Tue Nov 15 2016 Miguel Angel Ajo <majopela@redhat.com> 1:8.1.2-11
- reset provider network bridges to standalone mode, rhbz#1394890

* Wed Nov 09 2016 Venkata Anil Kommaddi <vkommadi@redhat.com> 1:8.1.2-10
- Avoid duplicate ipset processing for security groups, rhbz#1393437
- New option for num_threads for state change server

* Tue Nov 08 2016 Venkata Anil Kommaddi <vkommadi@redhat.com> 1:8.1.2-9
- pstree is added as a dependency to the tests package, rhbz#1392909

* Tue Oct 11 2016 Jakub Libosvar <jlibosva@redhat.com> - 1:8.1.2-8
- Ignore gre0 and gretap0 devices in netns cleanup script, rhbz#1382718

* Thu Oct 6 2016 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.1.2-7
- Load br_netfilter if present for iptables aware agents, rhbz#1382412

* Fri Sep 23 2016 Hynek Mlnarik <hmlnarik@redhat.com> 1:8.1.2-6
- ml2: allow retry on retriabable db error by precommit, rhbz#1378123
- Check for StaleData errors in retry decorator, rhbz#1378123
- Support for MultipleExceptions in db_api decorators, rhbz#1378123
- Convert multiple exception types in the API, rhbz#1378123

* Wed Sep 14 2016 Hynek Mlnarik <hmlnarik@redhat.com> 1:8.1.2-5
- Set secure fail mode for physical bridges, rhbz#1372369
- Pass timeout in milliseconds to timer_wait, rhbz#1366187

* Mon Aug 15 2016 Jakub Libosvar <jlibosva@redhat.com> - 1:8.1.2-4
- ovsdb: Don't let block() wait indefinitely, rhbz#1366187

* Thu Aug 11 2016 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.1.2-3
- Calculate MTU on every network fetch instead of on create (rhbz#1365617)

* Wed Aug 10 2016 Ihar Hrachyshka <ihrachys@redhat.com> 1:8.1.2-2
- ovs: set device MTU after it's moved into a namespace (rhbz#1365622)
- Don't use exponential back-off for report_state (rhbz#1359894)
- Revert "Revert "Remove threading before process forking"" (rhbz#1346759)
- Adopt to config_dir option being a list and not a string (rhbz#1339707)

* Thu Jun 16 2016 Alan Pevec <alan.pevec@redhat.com> 1:8.1.2-1
- Update to 8.1.2

* Fri Jun 03 2016 Haikel Guemar <hguemar@fedoraproject.org> 1:8.1.1-1
- Update to 8.1.1
- Fix OVS startup

* Thu May 12 2016 Alan Pevec <alan.pevec@redhat.com> 1:8.1.0-1
- Update to 8.1.0

* Thu Apr  7 2016 Haïkel Guémar <hguemar@fedoraproject.org> - 1:8.0.0-1
- Upstream 8.0.0

* Sat Apr 02 2016 Haikel Guemar <hguemar@fedoraproject.org> 1:8.0.0-0.2.0rc1
- Update to 8.0.0.0rc3

* Thu Mar 24 2016 RDO <rdo-list@redhat.com> 8.0.0-0.1.0rc1
- RC1 Rebuild for Mitaka rc1
